# -*- mode: RPM-SPEC; indent-tabs-mode: nil -*-
%define tarbasename ldas-tools-diskcacheAPI
%define _docdir %{_datadir}/doc/%{tarbasename}-%{version}

%define check_cmake3  ( 0%{?rhel} && 0%{?rhel} <= 7 )

Summary: LDAS tools libdiskcacheAPI toolkit runtime files
Name: ldas-tools-diskcacheAPI
Version: 2.7.2
Release: 1%{?dist}
License: GPLv2+
URL: "https://wiki.ligo.org/Computing/LDASTools"
Group: Application/Scientific
BuildRoot: %{buildroot}
Source0: https://software.igwn.org/lscsoft/source/ldas-tools-diskcacheAPI-%{version}.tar.gz
Requires: ldas-tools-al >= 2.6.7
Requires: ldas-tools-ldasgen >= 2.7.3
Requires(pre): shadow-utils
%{?systemd_requires}
BuildRequires: gcc, gcc-c++, glibc
BuildRequires: make
BuildRequires: rpm-build
BuildRequires: openssl-devel
%if %{check_cmake3}
BuildRequires: cmake3 >= 3.6
BuildRequires: cmake
%else
BuildRequires: cmake >= 3.6
%endif
Buildrequires: doxygen
Buildrequires: pkgconfig
Buildrequires: zlib-devel
BuildRequires: ldas-tools-cmake >= 1.2.3
Buildrequires: ldas-tools-ldasgen-devel >= 2.7.3
Buildrequires: systemd

%description
This provides the runtime libraries for the diskcacheAPI library.

%package devel
Group: Development/Scientific
Summary: LDAS tools libdiskcacheAPI toolkit development files
Requires: ldas-tools-ldasgen-devel >= 2.7.3
Requires: ldas-tools-diskcacheAPI = %{version}
%description devel
This provides the develpement files the diskcacheAPI library.

%prep

%setup -c -T -D -a 0 -n %{name}-%{version}

%build
#------------------------------------------------------------------------
# This works around a bug in the current rpmbuild system whereby the
#   PKG_CONFIG_PATH is set by the system and does not allow for
#   user preference.
# This work around should be fixed in RH 7.1 or so
#------------------------------------------------------------------------
export PKG_CONFIG_PATH="${LDASTOOLSDEV_PKG_CONFIG_PATH:-}${LDASTOOLSDEV_PKG_CONFIG_PATH:+:}$PKG_CONFIG_PATH"

%if %{check_cmake3}
export CMAKE_PROGRAM=cmake3
%else
export CMAKE_PROGRAM=cmake
%endif

${CMAKE_PROGRAM} \
    -DCMAKE_BUILD_TYPE=RelWithDebInfo -DCMAKE_EXPORT_COMPILE_COMMANDS=1 \
    -DCMAKE_INSTALL_PREFIX=%{_prefix} \
    -DCMAKE_INSTALL_DOCDIR=%{_docdir} \
    %{tarbasename}-%{version}

make V=1 %{?_smp_mflags}

%install
rm -rf %{buildroot}
#--------------------------------------------------------------
# install lscsoft specific files
#--------------------------------------------------------------
make V=1 install DESTDIR=%{buildroot}
#--------------------------------------------------------------
#--------------------------------------------------------------
find %{buildroot} -name \*.la -exec rm -f {} \;

mkdir -p %{buildroot}%{_sharedstatedir}/diskcache
mkdir -p %{buildroot}/var/log/diskcache

# Remove the init script that has been replaced by a systemd unit file
rm -f %{buildroot}/etc/initd.d/diskcached

%pre
getent group diskcache >/dev/null || groupadd -r diskcache
getent passwd diskcache >/dev/null || \
    useradd -r -g diskcache -d %{_sharedstatedir}/diskcache -s /sbin/nologin \
    -c "Dedicated diskcache service account" diskcache
exit 0

%post
/sbin/ldconfig
%systemd_post diskcache.service

%preun
%systemd_preun diskcache.service

%postun
/sbin/ldconfig
%systemd_postun diskcache.service

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%dir %{_sysconfdir}/diskcache
%attr(0755,diskcache,diskcache) %dir /var/log/diskcache
%attr(0755,diskcache,diskcache) %dir %{_sharedstatedir}/diskcache

%{_bindir}/diskcache
%{_bindir}/ldas-cache-dump-verify
%{_libdir}/libdiskcache*.so.*
%{_unitdir}/diskcache.service
%{_sysconfdir}/diskcache/diskcache.rsc.sample
%{_docdir}/diskcache_poller
%{_docdir}/diskcache_server

%files devel
%defattr(-,root,root)
%{_includedir}/diskcacheAPI
%{_libdir}/libdiskcache.*a
%{_libdir}/libdiskcache*.so
%{_docdir}
%{_libdir}/pkgconfig/ldastools-diskcache.pc

%changelog
* Wed Sep 29 2021 Edward Maros <ed.maros@ligo.org> - 2.7.2-1
- Built for new release

* Tue Mar 9 2021 Edward Maros <ed.maros@ligo.org> - 2.7.1-1
- Built for new release

* Wed Aug 14 2019 Edward Maros <ed.maros@ligo.org> - 2.7.0-1
- Built for new release

* Thu Dec 06 2018 Edward Maros <ed.maros@ligo.org> - 2.6.3-1
- Built for new release

* Tue Nov 27 2018 Edward Maros <ed.maros@ligo.org> - 2.6.2-1
- Built for new release

* Sat Oct 22 2016 Edward Maros <ed.maros@ligo.org> - 2.5.5-1
- Built for new release

* Mon Oct 10 2016 Edward Maros <ed.maros@ligo.org> - 2.5.4-1
- Built for new release

* Mon Sep 26 2016 Edward Maros <ed.maros@ligo.org> - 2.5.3-1
- Fixed diskcache to recover from devices going offline (#4645)

* Wed Mar 23 2016 Edward Maros <ed.maros@ligo.org> - 2.4.99.4-1
- Made build be verbose

* Fri Mar 11 2016 Edward Maros <ed.maros@ligo.org> - 2.4.99.1-1
- Corrections for RPM build

* Thu Mar 03 2016 Edward Maros <ed.maros@ligo.org> - 2.4.99.0-1
- Breakout into separate source package

* Tue Oct 11 2011 Edward Maros <ed.maros@ligo.org> - 1.19.13-1
- Initial build.
